﻿using UnityEngine;
using System.Collections;

public class Brick : MonoBehaviour {
	
	public AudioClip crack;
	public AudioClip smash;
	public Sprite[] hitSprites;
	public static int breakableCount = 0;
	
	
	private int timesHit;
	private LevelManager levelManager;
	bool isBreakable; 
	// Use this for initialization
	void Start () {
		isBreakable = (this.tag == "Breakable");
		//keep track of breakable bricks
		if (isBreakable) {
			breakableCount = breakableCount + 1;
			//or can write brickCount++;
			
		}
		timesHit = 0;
		levelManager = GameObject.FindObjectOfType<LevelManager>();
		
	}
	
	// Update is called once per frame
	void Update () {
	
	}
	void OnCollisionEnter2D (Collision2D col) {
			AudioSource.PlayClipAtPoint (crack, transform.position);
			if (isBreakable) {
			HandleHits ();
		}
	}
		
		
		void HandleHits (){
			timesHit = timesHit + 1;
	//another way to write the times hit is timesHit++;
	
			int maxHits = hitSprites.Length + 1;
	
			if (timesHit >= maxHits){
				breakableCount = breakableCount - 1;
				
				AudioSource.PlayClipAtPoint (smash, transform.position);
				levelManager.BrickDestroyed ();
			
				Destroy (gameObject);
	} 		else {
				LoadSprites();
		
		
		}
		}
		
		void LoadSprites (){
			int spriteIndex = timesHit - 1;
			if (hitSprites[spriteIndex]){    //if theres no spite to be found, it wont change the image in the missing element (ie element 0 element 1 example brick became invisible
				this.GetComponent<SpriteRenderer>().sprite = hitSprites[spriteIndex];
			}
			}
		
		
		
		//TODO remove this method once we can actually win!
		void SimulateWin (){
		levelManager.LoadNextLevel();
			
		}
}
